Index: /palm/trunk/SOURCE/poismg.f90
===================================================================
--- /palm/trunk/SOURCE/poismg.f90	(revision 1319)
+++ /palm/trunk/SOURCE/poismg.f90	(revision 1320)
@@ -23,5 +23,11 @@
 ! Current revisions:
 ! -----------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -108,18 +114,32 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog    
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  d, p_loc
+
+    USE control_parameters,                                                    &
+        ONLY:  gathered_size, grid_level, grid_level_count,                    &
+               maximum_grid_level, message_string, mgcycles, mg_cycles,        &
+               mg_switch_to_pe0_level, residual_limit, subdomain_size
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxlg, nxl_mg, nxr, nxrg, nxr_mg, nys, nysg, nys_mg, nyn,   &
+               nyng, nyn_mg, nzb, nzt, nzt_mg
+
+    USE kinds
+
     USE pegrid
 
     IMPLICIT NONE
 
-    REAL    ::  maxerror, maximum_mgcycles, residual_norm
-
-    REAL, DIMENSION(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) ::  r 
-
-    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  p3
+    REAL(wp) ::  maxerror          !:
+    REAL(wp) ::  maximum_mgcycles  !:
+    REAL(wp) ::  residual_norm     !:
+
+    REAL(wp), DIMENSION(nzb:nzt+1,nys-1:nyn+1,nxl-1:nxr+1) ::  r  !:
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  p3  !:
 
 
@@ -220,17 +240,39 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
-    USE pegrid
+    USE arrays_3d,                                                             &
+        ONLY:  f1_mg, f2_mg, f3_mg
+
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,   &
+               inflow_n, inflow_r, inflow_s, outflow_l, outflow_n, outflow_r,  &
+               outflow_s
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx2_mg, ddy2_mg
+
+    USE indices,                                                               &
+        ONLY:  flags, wall_flags_1, wall_flags_2, wall_flags_3, wall_flags_4,  &
+               wall_flags_5, wall_flags_6, wall_flags_7, wall_flags_8,         &
+               wall_flags_9, wall_flags_10, nxl_mg, nxr_mg, nys_mg, nyn_mg,    &
+               nzb, nzt_mg
+
+    USE kinds
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, l
-
-    REAL, DIMENSION(nzb:nzt_mg(grid_level)+1,                                  &
+    INTEGER(iwp) ::  i
+    INTEGER(iwp) ::  j
+    INTEGER(iwp) ::  k
+    INTEGER(iwp) ::  l
+
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
                     nys_mg(grid_level)-1:nyn_mg(grid_level)+1,                 &
-                    nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  f_mg, p_mg, r
+                    nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  f_mg  !:
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
+                    nys_mg(grid_level)-1:nyn_mg(grid_level)+1,                 &
+                    nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  p_mg  !:
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
+                    nys_mg(grid_level)-1:nyn_mg(grid_level)+1,                 &
+                    nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  r     !:
 
 !
@@ -336,24 +378,52 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE grid_variables
-    USE indices
-    USE pegrid
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,   &
+               inflow_n, inflow_r, inflow_s, outflow_l, outflow_n, outflow_r,  &
+               outflow_s
+
+    USE indices,                                                               &
+        ONLY:  flags, wall_flags_1, wall_flags_2, wall_flags_3, wall_flags_4,  &
+               wall_flags_5, wall_flags_6, wall_flags_7, wall_flags_8,         &
+               wall_flags_9, wall_flags_10, nxl_mg, nxr_mg, nys_mg, nyn_mg,    &
+               nzb, nzt_mg
+
+    USE kinds
 
     IMPLICIT NONE
 
-    INTEGER ::  i, ic, j, jc, k, kc, l
-
-    REAL ::  rkjim, rkjip, rkjmi, rkjmim, rkjmip, rkjpi, rkjpim, rkjpip,       &
-             rkmji, rkmjim, rkmjip, rkmjmi, rkmjmim, rkmjmip, rkmjpi, rkmjpim, &
-             rkmjpip
-
-    REAL, DIMENSION(nzb:nzt_mg(grid_level)+1,                            &
-                    nys_mg(grid_level)-1:nyn_mg(grid_level)+1,           &
-                    nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  f_mg
-
-    REAL, DIMENSION(nzb:nzt_mg(grid_level+1)+1,                          &
-                    nys_mg(grid_level+1)-1:nyn_mg(grid_level+1)+1,       &
-                    nxl_mg(grid_level+1)-1:nxr_mg(grid_level+1)+1) ::  r
+    INTEGER(iwp) ::  i    !:
+    INTEGER(iwp) ::  ic   !:
+    INTEGER(iwp) ::  j    !:
+    INTEGER(iwp) ::  jc   !:
+    INTEGER(iwp) ::  k    !:
+    INTEGER(iwp) ::  kc   !:
+    INTEGER(iwp) ::  l    !:
+
+    REAL(wp) ::  rkjim    !:
+    REAL(wp) ::  rkjip    !:
+    REAL(wp) ::  rkjmi    !:
+    REAL(wp) ::  rkjmim   !:
+    REAL(wp) ::  rkjmip   !:
+    REAL(wp) ::  rkjpi    !:
+    REAL(wp) ::  rkjpim   !:
+    REAL(wp) ::  rkjpip   !:
+    REAL(wp) ::  rkmji    !:
+    REAL(wp) ::  rkmjim   !:
+    REAL(wp) ::  rkmjip   !:
+    REAL(wp) ::  rkmjmi   !:
+    REAL(wp) ::  rkmjmim  !:
+    REAL(wp) ::  rkmjmip  !:
+    REAL(wp) ::  rkmjpi   !:
+    REAL(wp) ::  rkmjpim  !:
+    REAL(wp) ::  rkmjpip  !:
+
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                            &
+                        nys_mg(grid_level)-1:nyn_mg(grid_level)+1,           &
+                        nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  f_mg  !:
+
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level+1)+1,                          &
+                        nys_mg(grid_level+1)-1:nyn_mg(grid_level+1)+1,       &
+                        nxl_mg(grid_level+1)-1:nxr_mg(grid_level+1)+1) ::  r !:
 
 !
@@ -516,19 +586,28 @@
 !------------------------------------------------------------------------------!
 
-    USE control_parameters
-    USE pegrid
-    USE indices
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,   &
+               inflow_n, inflow_r, inflow_s, outflow_l, outflow_n, outflow_r,  &
+               outflow_s
+
+    USE indices,                                                               &
+        ONLY:  nxl_mg, nxr_mg, nys_mg, nyn_mg, nzb, nzt_mg
+
+    USE kinds
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, l
-
-    REAL, DIMENSION(nzb:nzt_mg(grid_level-1)+1,                           &
-                    nys_mg(grid_level-1)-1:nyn_mg(grid_level-1)+1,        &
-                    nxl_mg(grid_level-1)-1:nxr_mg(grid_level-1)+1 ) ::  p
-
-    REAL, DIMENSION(nzb:nzt_mg(grid_level)+1,                           &
-                    nys_mg(grid_level)-1:nyn_mg(grid_level)+1,          &
-                    nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  temp
+    INTEGER(iwp) ::  i  !:
+    INTEGER(iwp) ::  j  !:
+    INTEGER(iwp) ::  k  !:
+    INTEGER(iwp) ::  l  !:
+
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level-1)+1,                           &
+                        nys_mg(grid_level-1)-1:nyn_mg(grid_level-1)+1,        &
+                        nxl_mg(grid_level-1)-1:nxr_mg(grid_level-1)+1 ) ::  p  !:
+
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                           &
+                        nys_mg(grid_level)-1:nyn_mg(grid_level)+1,          &
+                        nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  temp  !:
 
 
@@ -613,22 +692,53 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
-    USE pegrid
+    USE arrays_3d,                                                             &
+        ONLY:  f1_mg, f2_mg, f3_mg
+
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, grid_level, ibc_p_b, ibc_p_t, inflow_l,   &
+               inflow_n, inflow_r, inflow_s, ngsrb, outflow_l, outflow_n,      &
+               outflow_r, outflow_s
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx2_mg, ddy2_mg
+
+    USE indices,                                                               &
+        ONLY:  flags, wall_flags_1, wall_flags_2, wall_flags_3, wall_flags_4,  &
+               wall_flags_5, wall_flags_6, wall_flags_7, wall_flags_8,         &
+               wall_flags_9, wall_flags_10, nxl_mg, nxr_mg, nys_mg, nyn_mg,    &
+               nzb, nzt_mg
+
+    USE kinds
 
     IMPLICIT NONE
 
-    INTEGER :: colour, i, ic, j, jc, jj, k, l, n
-
-    LOGICAL :: unroll
-
-    REAL ::  wall_left, wall_north, wall_right, wall_south, wall_total, wall_top
-
-    REAL, DIMENSION(nzb:nzt_mg(grid_level)+1,                                 &
-                    nys_mg(grid_level)-1:nyn_mg(grid_level)+1,                &
-                    nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  f_mg, p_mg
+    INTEGER(iwp) :: color    !:
+    INTEGER(iwp) :: i        !:
+    INTEGER(iwp) :: ic       !:
+    INTEGER(iwp) :: j        !:
+    INTEGER(iwp) :: jc       !:
+    INTEGER(iwp) :: jj       !:
+    INTEGER(iwp) :: k        !:
+    INTEGER(iwp) :: l        !:
+    INTEGER(iwp) :: n        !:
+
+    LOGICAL :: unroll        !:
+
+    REAL(wp) ::  wall_left   !:
+    REAL(wp) ::  wall_north  !:
+    REAL(wp) ::  wall_right  !:
+    REAL(wp) ::  wall_south  !:
+    REAL(wp) ::  wall_total  !:
+    REAL(wp) ::  wall_top    !:
+
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
+                        nys_mg(grid_level)-1:nyn_mg(grid_level)+1,             &
+                        nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  f_mg  !:
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
+                        nys_mg(grid_level)-1:nyn_mg(grid_level)+1,             &
+                        nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  p_mg  !:
 
     l = grid_level
@@ -664,5 +774,5 @@
     DO  n = 1, ngsrb
        
-       DO  colour = 1, 2
+       DO  color = 1, 2
 
           IF ( .NOT. unroll )  THEN
@@ -673,5 +783,5 @@
 !--          Without unrolling of loops, no cache optimization
              DO  i = nxl_mg(l), nxr_mg(l), 2
-                DO  j = nys_mg(l) + 2 - colour, nyn_mg(l), 2 
+                DO  j = nys_mg(l) + 2 - color, nyn_mg(l), 2 
                    DO  k = nzb+1, nzt_mg(l), 2
 !                      p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
@@ -703,5 +813,5 @@
    
              DO  i = nxl_mg(l)+1, nxr_mg(l), 2
-                DO  j = nys_mg(l) + (colour-1), nyn_mg(l), 2
+                DO  j = nys_mg(l) + (color-1), nyn_mg(l), 2
                    DO  k = nzb+1, nzt_mg(l), 2 
                       p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
@@ -726,5 +836,5 @@
   
              DO  i = nxl_mg(l), nxr_mg(l), 2
-                DO  j = nys_mg(l) + (colour-1), nyn_mg(l), 2
+                DO  j = nys_mg(l) + (color-1), nyn_mg(l), 2
                    DO  k = nzb+2, nzt_mg(l), 2
                       p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
@@ -749,5 +859,5 @@
 
              DO  i = nxl_mg(l)+1, nxr_mg(l), 2
-                DO  j = nys_mg(l) + 2 - colour, nyn_mg(l), 2
+                DO  j = nys_mg(l) + 2 - color, nyn_mg(l), 2
                    DO  k = nzb+2, nzt_mg(l), 2
                       p_mg(k,j,i) = 1.0 / f1_mg(k,l) * (                       &
@@ -780,5 +890,5 @@
                 DO  jc = nys_mg(l), nyn_mg(l), 4
                    i  = ic
-                   jj = jc+2-colour
+                   jj = jc+2-color
                    DO  k = nzb+1, nzt_mg(l), 2
                       j = jj
@@ -819,5 +929,5 @@
    
                    i  = ic+1
-                   jj = jc+colour-1
+                   jj = jc+color-1
                    DO  k = nzb+1, nzt_mg(l), 2 
                       j =jj
@@ -858,5 +968,5 @@
 
                    i  = ic
-                   jj = jc+colour-1
+                   jj = jc+color-1
                    DO  k = nzb+2, nzt_mg(l), 2
                       j =jj
@@ -897,5 +1007,5 @@
 
                    i  = ic+1
-                   jj = jc+2-colour
+                   jj = jc+2-color
                    DO  k = nzb+2, nzt_mg(l), 2
                       j =jj
@@ -1027,20 +1137,38 @@
  SUBROUTINE mg_gather( f2, f2_sub )
 
-    USE control_parameters
-    USE cpulog
-    USE indices
+    USE control_parameters,                                                    &
+        ONLY:  grid_level
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  mg_loc_ind, nxl_mg, nxr_mg, nys_mg, nyn_mg, nzb, nzt_mg
+
+    USE kinds
+
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER ::  i, il, ir, j, jn, js, k, nwords
-
-    REAL, DIMENSION(nzb:nzt_mg(grid_level)+1,                            &
-                    nys_mg(grid_level)-1:nyn_mg(grid_level)+1,           &
-                    nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  f2, f2_l
-
-    REAL, DIMENSION(nzb:mg_loc_ind(5,myid)+1,                            &
-                    mg_loc_ind(3,myid)-1:mg_loc_ind(4,myid)+1,           &
-                    mg_loc_ind(1,myid)-1:mg_loc_ind(2,myid)+1) ::  f2_sub
+    INTEGER(iwp) ::  i       !:
+    INTEGER(iwp) ::  il      !:
+    INTEGER(iwp) ::  ir      !:
+    INTEGER(iwp) ::  j       !:
+    INTEGER(iwp) ::  jn      !:
+    INTEGER(iwp) ::  js      !:
+    INTEGER(iwp) ::  k       !:
+    INTEGER(iwp) ::  nwords  !:
+
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
+                    nys_mg(grid_level)-1:nyn_mg(grid_level)+1,                 &
+                    nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  f2    !:
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
+                    nys_mg(grid_level)-1:nyn_mg(grid_level)+1,                 &
+                    nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) ::  f2_l  !:
+
+    REAL(wp), DIMENSION(nzb:mg_loc_ind(5,myid)+1,                              &
+                        mg_loc_ind(3,myid)-1:mg_loc_ind(4,myid)+1,             &
+                        mg_loc_ind(1,myid)-1:mg_loc_ind(2,myid)+1) ::  f2_sub  !:
 
 
@@ -1091,20 +1219,28 @@
 !-- non-blocking communication
 
-    USE control_parameters
-    USE cpulog
-    USE indices
+    USE control_parameters,                                                    &
+        ONLY:  grid_level
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point_s
+
+    USE indices,                                                               &
+        ONLY:  mg_loc_ind, nxl_mg, nxr_mg, nys_mg, nyn_mg, nzb, nzt_mg
+
+    USE kinds
+
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER ::  nwords
-
-    REAL, DIMENSION(nzb:nzt_mg(grid_level-1)+1,                            &
-                    nys_mg(grid_level-1)-1:nyn_mg(grid_level-1)+1,         &
-                    nxl_mg(grid_level-1)-1:nxr_mg(grid_level-1)+1) ::  p2
-
-    REAL, DIMENSION(nzb:mg_loc_ind(5,myid)+1,                              &
-                    mg_loc_ind(3,myid)-1:mg_loc_ind(4,myid)+1,             &
-                    mg_loc_ind(1,myid)-1:mg_loc_ind(2,myid)+1) ::  p2_sub
+    INTEGER(iwp) ::  nwords  !:
+
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level-1)+1,                            &
+                        nys_mg(grid_level-1)-1:nyn_mg(grid_level-1)+1,         &
+                        nxl_mg(grid_level-1)-1:nxr_mg(grid_level-1)+1) ::  p2  !:
+
+    REAL(wp), DIMENSION(nzb:mg_loc_ind(5,myid)+1,                              &
+                        mg_loc_ind(3,myid)-1:mg_loc_ind(4,myid)+1,             &
+                        mg_loc_ind(1,myid)-1:mg_loc_ind(2,myid)+1) ::  p2_sub  !:
 
 !
@@ -1138,24 +1274,53 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_dirrad, bc_lr_raddir, bc_ns_dirrad, bc_ns_raddir,         &
+               gamma_mg, grid_level, grid_level_count, ibc_p_b, ibc_p_t,       &
+               inflow_l, inflow_n, inflow_r, inflow_s, maximum_grid_level,     &
+               mg_switch_to_pe0_level, mg_switch_to_pe0, ngsrb, outflow_l,     &
+               outflow_n, outflow_r, outflow_s
+
+
+    USE indices,                                                               &
+        ONLY:  mg_loc_ind, nxl, nxl_mg, nxr, nxr_mg, nys, nys_mg, nyn,         &
+               nyn_mg, nzb, nzt, nzt_mg
+
+    USE kinds
+
     USE pegrid
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k, nxl_mg_save, nxr_mg_save, nyn_mg_save, nys_mg_save, &
-                nzt_mg_save
-
-    REAL, DIMENSION(nzb:nzt_mg(grid_level)+1,                                  &
-                 nys_mg(grid_level)-1:nyn_mg(grid_level)+1,                    &
-                 nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) :: f_mg, p_mg, p3, r
-
-    REAL, DIMENSION(nzb:nzt_mg(grid_level-1)+1,                                &
-                    nys_mg(grid_level-1)-1:nyn_mg(grid_level-1)+1,             &
-                    nxl_mg(grid_level-1)-1:nxr_mg(grid_level-1)+1) ::  f2, p2
-
-    REAL, DIMENSION(:,:,:), ALLOCATABLE ::  f2_sub, p2_sub
+    INTEGER(iwp) ::  i            !:
+    INTEGER(iwp) ::  j            !:
+    INTEGER(iwp) ::  k            !:
+    INTEGER(iwp) ::  nxl_mg_save  !:
+    INTEGER(iwp) ::  nxr_mg_save  !:
+    INTEGER(iwp) ::  nyn_mg_save  !:
+    INTEGER(iwp) ::  nys_mg_save  !:
+    INTEGER(iwp) ::  nzt_mg_save  !:
+
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
+                        nys_mg(grid_level)-1:nyn_mg(grid_level)+1,             &
+                        nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) :: f_mg  !:
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
+                        nys_mg(grid_level)-1:nyn_mg(grid_level)+1,             &
+                        nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) :: p_mg  !:
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
+                        nys_mg(grid_level)-1:nyn_mg(grid_level)+1,             &
+                        nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) :: p3    !:
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level)+1,                              &
+                        nys_mg(grid_level)-1:nyn_mg(grid_level)+1,             &
+                        nxl_mg(grid_level)-1:nxr_mg(grid_level)+1) :: r     !:
+
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level-1)+1,                            &
+                        nys_mg(grid_level-1)-1:nyn_mg(grid_level-1)+1,         &
+                        nxl_mg(grid_level-1)-1:nxr_mg(grid_level-1)+1) ::  f2  !:
+    REAL(wp), DIMENSION(nzb:nzt_mg(grid_level-1)+1,                            &
+                        nys_mg(grid_level-1)-1:nyn_mg(grid_level-1)+1,         &
+                        nxl_mg(grid_level-1)-1:nxr_mg(grid_level-1)+1) ::  p2  !:
+
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  f2_sub  !:
+    REAL(wp), DIMENSION(:,:,:), ALLOCATABLE ::  p2_sub  !:
 
 !
Index: /palm/trunk/SOURCE/prandtl_fluxes.f90
===================================================================
--- /palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 1319)
+++ /palm/trunk/SOURCE/prandtl_fluxes.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! -----------------
-! 
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -40,38 +46,4 @@
 ! 978 2012-08-09 08:28:32Z fricke
 ! roughness length for scalar quantities z0h added
-!
-! 759 2011-09-15 13:58:31Z raasch
-! Bugfix for ts limitation
-!
-! 709 2011-03-30 09:31:40Z raasch
-! formatting adjustments
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! Changed surface boundary conditions for u and v from mirror to Dirichlet.
-! Therefore u(uzb,:,:) and v(nzb,:,:) are now representative for height z0.
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng
-!
-! 315 2009-05-13 10:57:59Z raasch
-! Saturation condition at (sea) surface is not used in precursor runs (only
-! in the following coupled runs)
-! Bugfix: qsws was calculated in case of constant heatflux = .FALSE.
-!
-! 187 2008-08-06 16:25:09Z letzel
-! Bugfix: modification of the calculation of the vertical turbulent momentum
-! fluxes u'w' and v'w'
-! Bugfix: change definition of us_wall from 1D to 2D
-! Change: modification of the integrated version of the profile function for 
-! momentum for unstable stratification (does not effect results)
-!
-! 108 2007-08-24 15:10:38Z letzel
-! assume saturation at k=nzb_s_inner(j,i) for atmosphere coupled to ocean
-!
-! 75 2007-03-22 09:54:05Z raasch
-! moisture renamed humidity
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.19  2006/04/26 12:24:35  raasch
-! +OpenMP directives and optimization (array assignments replaced by DO loops)
 !
 ! Revision 1.1  1998/01/23 10:06:06  raasch
@@ -85,14 +57,34 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE control_parameters
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  e, pt, q, qs, qsws, rif, shf, ts, u, us, usws, v, vpt, vsws,    &
+               zu, zw, z0, z0h
+
+    USE control_parameters,                                                    &
+        ONLY:  constant_heatflux, constant_waterflux, coupling_mode, g,        &
+               humidity, ibc_e_b, kappa, large_scale_forcing, lsf_surf,        &
+               passive_scalar, pt_surface, q_surface, rif_max, rif_min,        &
+               run_coupled, surface_pressure
+
+    USE indices,                                                               &
+        ONLY:  nxl, nxlg, nxr, nxrg, nys, nysg, nyn, nyng, nzb_s_inner,        &
+               nzb_u_inner, nzb_v_inner
+
+    USE kinds
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k
-    LOGICAL ::  coupled_run
-    REAL    ::  a, b, e_q, rifm, uv_total, z_p
+    INTEGER(iwp) ::  i            !:
+    INTEGER(iwp) ::  j            !:
+    INTEGER(iwp) ::  k            !:
+
+    LOGICAL      ::  coupled_run  !:
+
+    REAL(wp)     ::  a            !:
+    REAL(wp)     ::  b            !:
+    REAL(wp)     ::  e_q          !:
+    REAL(wp)     ::  rifm         !:
+    REAL(wp)     ::  uv_total     !:
+    REAL(wp)     ::  z_p          !:
 
 !
Index: /palm/trunk/SOURCE/pres.f90
===================================================================
--- /palm/trunk/SOURCE/pres.f90	(revision 1319)
+++ /palm/trunk/SOURCE/pres.f90	(revision 1320)
@@ -20,5 +20,11 @@
 ! Current revisions:
 ! ------------------
-!
+! ONLY-attribute added to USE-statements,
+! kind-parameters added to all INTEGER and REAL declaration statements,
+! kinds are defined in new module kinds,
+! old module precision_kind is removed,
+! revision history before 2012 removed,
+! comment fields (!:) to be used for variable explanations added to
+! all variable declaration statements
 !
 ! Former revisions:
@@ -61,71 +67,4 @@
 ! 1003 2012-09-14 14:35:53Z raasch
 ! adjustment of array tend for cases with unequal subdomain sizes removed
-!
-! 778 2011-11-07 14:18:25Z fricke
-! New allocation of tend when multigrid is used and the collected field on PE0
-! has more grid points than the subdomain of an PE.
-!
-! 719 2011-04-06 13:05:23Z gryschka
-! Bugfix in volume flow control for double cyclic boundary conditions
-!
-! 709 2011-03-30 09:31:40Z raasch
-! formatting adjustments
-!
-! 707 2011-03-29 11:39:40Z raasch
-! Calculation of weighted average of p is now handled in the same way
-! regardless of the number of ghost layers (advection scheme),
-! multigrid and sor method are using p_loc for iterative advancements of
-! pressure, 
-! localsum calculation modified for proper OpenMP reduction,
-! bc_lr/ns replaced by bc_lr/ns_cyc
-!
-! 693 2011-03-08 09:..:..Z raasch
-! bugfix: weighting coefficient added to ibm branch
-!
-! 680 2011-02-04 23:16:06Z gryschka
-! bugfix: collective_wait
-!
-! 675 2011-01-19 10:56:55Z suehring
-! Removed bugfix while copying tend.
-!
-! 673 2011-01-18 16:19:48Z suehring
-! Weighting coefficients added for right computation of the pressure during
-! Runge-Kutta substeps. 
-!
-! 667 2010-12-23 12:06:00Z suehring/gryschka
-! New allocation of tend when ws-scheme and multigrid is used. This is due to 
-! reasons of perforance of the data_exchange. The same is done with p after
-! poismg is called.
-! nxl-1, nxr+1, nys-1, nyn+1 replaced by nxlg, nxrg, nysg, nyng when no 
-! multigrid is used. Calls of exchange_horiz are modified.
-! bugfix: After pressure correction no volume flow correction in case of 
-! non-cyclic boundary conditions 
-! (has to be done only before pressure correction)
-! Call of SOR routine is referenced with ddzu_pres.
-!
-! 622 2010-12-10 08:08:13Z raasch
-! optional barriers included in order to speed up collective operations
-!
-! 151 2008-03-07 13:42:18Z raasch
-! Bugfix in volume flow control for non-cyclic boundary conditions
-!
-! 106 2007-08-16 14:30:26Z raasch
-! Volume flow conservation added for the remaining three outflow boundaries
-!
-! 85 2007-05-11 09:35:14Z raasch
-! Division through dt_3d replaced by multiplication of the inverse.
-! For performance optimisation, this is done in the loop calculating the
-! divergence instead of using a seperate loop.
-!
-! 75 2007-03-22 09:54:05Z raasch
-! Volume flow control for non-cyclic boundary conditions added (currently only
-! for the north boundary!!), 2nd+3rd argument removed from exchange horiz,
-! mean vertical velocity is removed in case of Neumann boundary conditions
-! both at the bottom and the top
-!
-! RCS Log replace by Id keyword, revision history cleaned up
-!
-! Revision 1.25  2006/04/26 13:26:12  raasch
-! OpenMP optimization (+localsum, threadsum)
 !
 ! Revision 1.1  1997/07/24 11:24:44  raasch
@@ -140,22 +79,52 @@
 !------------------------------------------------------------------------------!
 
-    USE arrays_3d
-    USE constants
-    USE control_parameters
-    USE cpulog
-    USE grid_variables
-    USE indices
+    USE arrays_3d,                                                             &
+        ONLY:  d, ddzu, ddzu_pres, ddzw, dzw, p, p_loc, tend, u, v, w
+
+    USE control_parameters,                                                    &
+        ONLY:  bc_lr_cyc, bc_ns_cyc, conserve_volume_flow, dt_3d,              &
+               gathered_size, ibc_p_b, ibc_p_t, intermediate_timestep_count,   &
+               mg_switch_to_pe0_level, on_device, outflow_l, outflow_n,        &
+               outflow_r, outflow_s, psolver, simulated_time, subdomain_size,  &
+               topography, volume_flow, volume_flow_area, volume_flow_initial
+
+    USE cpulog,                                                                &
+        ONLY:  cpu_log, log_point, log_point_s
+
+    USE grid_variables,                                                        &
+        ONLY:  ddx, ddy
+
+    USE indices,                                                               &
+        ONLY:  nbgp, ngp_2dh_outer, nx, nxl, nxlg, nxl_mg, nxr, nxrg, nxr_mg,  &
+               ny, nys, nysg, nys_mg, nyn, nyng, nyn_mg, nzb, nzb_s_inner,     &
+               nzb_u_inner, nzb_v_inner, nzb_w_inner, nzb_2d, nzt, nzt_mg,     &
+               rflags_s_inner
+
+    USE kinds
+
     USE pegrid
-    USE poisfft_mod
-    USE statistics
+
+    USE poisfft_mod,                                                           &
+        ONLY:  poisfft
+
+    USE statistics,                                                            &
+        ONLY:  statistic_regions, sums_divnew_l, sums_divold_l, weight_pres,   &
+               weight_substep
 
     IMPLICIT NONE
 
-    INTEGER ::  i, j, k
-
-    REAL    ::  ddt_3d, localsum, threadsum, d_weight_pres
-
-    REAL, DIMENSION(1:2) ::  volume_flow_l, volume_flow_offset
-    REAL, DIMENSION(1:nzt) ::  w_l, w_l_l
+    INTEGER(iwp) ::  i              !:
+    INTEGER(iwp) ::  j              !:
+    INTEGER(iwp) ::  k              !:
+
+    REAL(wp)     ::  ddt_3d         !:
+    REAL(wp)     ::  localsum       !:
+    REAL(wp)     ::  threadsum      !:
+    REAL(wp)     ::  d_weight_pres  !:
+
+    REAL(wp), DIMENSION(1:2)   ::  volume_flow_l       !:
+    REAL(wp), DIMENSION(1:2)   ::  volume_flow_offset  !:
+    REAL(wp), DIMENSION(1:nzt) ::  w_l                 !:
+    REAL(wp), DIMENSION(1:nzt) ::  w_l_l               !:
 
 
